{
  config,
  lib,
  pkgs,
  ...
}:
let
  cfg = config.feature.tmux;
in
{
  options.feature.tmux = {
    enable = lib.mkEnableOption "Set up tmux";
  };

  config = lib.mkIf cfg.enable {
    programs.tmux = {
      enable = true;
      baseIndex = 1;
      plugins = with pkgs.tmuxPlugins; [
        catppuccin
      ];
      extraConfig = builtins.readFile ./tmux.conf;
    };
  };
}
