-- Global settings
vim.g.loaded_netrw = 1
vim.g.loaded_netrwPlugin = 1
vim.g.mapleader = " "

vim.opt.termguicolors = true
vim.opt.expandtab = true

vim.cmd.colorscheme "catppuccin"

-- Custom bindings
vim.keymap.set("n", "<leader>n", "<cmd>bn<CR>", { noremap = true, silent = true })
vim.keymap.set("n", "<leader>p", "<cmd>bp<CR>", { noremap = true, silent = true })

-- Bufferline (tabs)
require("bufferline").setup{}

-- Lualine (status line)
require("lualine").setup{}

-- Telescope (anything search)
vim.keymap.set("n", "<leader>b", "<cmd>Telescope buffers<CR>", { noremap = true, silent = true })
vim.keymap.set("n", "<leader>f", "<cmd>Telescope find_files<CR>", { noremap = true, silent = true })

-- lspconfig (LSPs)
vim.lsp.enable("nil")
vim.lsp.enable("pyright")
vim.lsp.enable("rust-analyzer")

